import { world, system, EquipmentSlot} from "@minecraft/server";
import { launchPlayer } from "./../../util/movements.js";
import { weaponDamageIndicator, generateUniqueId, stunDamageIndicator } from "./../../util/utils.js";
import { attackPlayerMeikyu, executer } from "./../../util/attackMethods.js";

const animations =[ 
    [
        {
            animation: "minced.polehammer.attack_sprint",
            knockback: [2,0.75],
            Player_Knockback: [1,0.25],
            type: "slash",
            attack_speed: 8,
            hit_number: 1,
            stun_type: "long",
            range: 3,
            distance: 1,
            targetNum: 1,
            damage_multiplier: 0.85,
            stun_damage_multiplier: 1.75,
            next_attack_time: 5,
            Unbreakable: false
        },
        {
            animation: "minced.polehammer.attack0",
            knockback: [0,0],
            Player_Knockback: [1,0],
            type: "blunt",
            attack_speed: 8,
            hit_number: 1,
            stun_type: "long",
            range: 3,
            distance: 1,
            targetNum: 1,
            damage_multiplier: 0.85,
            stun_damage_multiplier: 1.75,
            next_attack_time: 5,
            Unbreakable: false
        },
        {
            animation: "minced.polehammer.attack1",
            knockback: [0.5,0.25],
            Player_Knockback: [1,0.25],
            type: "blunt",
            attack_speed: 8,
            hit_number: 1,
            stun_type: "medium",
            range: 3,
            distance: 1,
            targetNum: 1,
            damage_multiplier: 0.85,
            stun_damage_multiplier: 1.75,
            next_attack_time: 5,
            Unbreakable: false
        },
        {
            animation: "minced.polehammer.attack2",
            knockback: [0.5,0.25],
            Player_Knockback: [1,0],
            type: "blunt",
            attack_speed: 8,
            hit_number: 1,
            stun_type: "long",
            range: 3,
            distance: 1,
            targetNum: 1,
            damage_multiplier: 0.85,
            stun_damage_multiplier: 1.75,
            next_attack_time: 5,
            Unbreakable: false
        }
    ]
]

const weapon = {
    name: 'polehammer',
    display_name: "PoleHammer",
    dual_wield: ["polehammer"],
    type: "polearm",
    can_block: true,
    block_damage: 50,
    block_power: 30,
    block_time: 4,
    clash_power: 50,
    front_dodge: [2, 0.25],
    back_dodge:[-2, 0.25],
    left_dodge:"none",
    right_dodge:"none",
    stylePrefixes: ["minced.polehammer"],
    cd: 20,
    available_moves: [],
    weaponSize: "small",
    execute(player, weapon, effect, mode, burn) {
        const cd = this.cd
        const blckdmg = this.block_damage
        let atkspd
        let lavander = weaponDamageIndicator(weapon)
        let stundamage = stunDamageIndicator(weapon.getTags())
        let critChance = Math.floor(Math.random()*9)
        let critDamage = 0
        critChance == 2 ? critDamage = Math.floor(Math.random() * lavander) : critDamage = 0
        lavander = JSON.parse(lavander) + critDamage
        let animChecker
        for(let i = animations[0].length - 1; i > 0; i--) {
            if(player.getDynamicProperty("combo") % i == 0) {
                animChecker = i
                break;
            }
        }
        let attackEffect = []
        attackEffect.push(effect)
        switch(mode) {
            case "sprint":{
                let propCheck = animations[0][0]
                let knockback = propCheck.knockback
                player.playAnimation(`animation.${propCheck.animation}`)
                atkspd = propCheck.attack_speed
                let Pknockback = propCheck.Player_Knockback 
                let effects = propCheck.type
                let stun = propCheck.stun_type
                let ranger = propCheck.range
                let distil = propCheck.distance
                let tgtnm = propCheck.targetNum
                let NAT = propCheck.next_attack_time
                let stunD = stundamage * propCheck.stun_damage_multiplier
                let breakable = propCheck.Unbreakable
                let hitCount = propCheck.hit_number
                system.runTimeout(()=>{
                    launchPlayer(player, Pknockback[0], Pknockback[1])
                },atkspd)
                if(animChecker == 3) {
                    player.addEffect("slow_falling", 16, { amplifier: 3, showParticles: false })
                }
                attackPlayerMeikyu(player, ranger, (lavander * propCheck.damage_multiplier), blckdmg, cd, atkspd, distil, tgtnm, "line_target", attackEffect, knockback, stun, "", effects, (animations[0].length - 1), stunD, NAT, breakable, "no cooldown",weapon, hitCount, true)
            } break;
            case "jump": {
                if(world.scoreboard.getObjective("exhaust").getScore(player) < 20) {
                    player.setDynamicProperty("attacking",0)
                    world.scoreboard.getObjective("combatCooldown").setScore(player, 10)
                    world.scoreboard.getObjective("combatCheck").setScore(player, 0)
                    player.runCommandAsync("tag @s remove attack")
                    return;
                }
                let propCheck = {
                    animation: "minced.polehammer.attack_jump",
                    knockback: [1,0.75],
                    Player_Knockback: [0,-1],
                    type: "blunt",
                    attack_speed: 8,
                    hit_number: 1,
                    stun_type: "long",
                    range: 3,
                    distance: 1,
                    targetNum: 1,
                    damage_multiplier: 1.5,
                    stun_damage_multiplier: 2,
                    next_attack_time: 16,
                    Unbreakable: false
                }
                let knockback = propCheck.knockback
                player.playAnimation(`animation.${propCheck.animation}`)
                atkspd = propCheck.attack_speed
                let Pknockback = propCheck.Player_Knockback 
                let effects = propCheck.type
                let stun = propCheck.stun_type
                let ranger = propCheck.range
                let distil = propCheck.distance
                let tgtnm = propCheck.targetNum
                let NAT = propCheck.next_attack_time
                let stunD = stundamage * propCheck.stun_damage_multiplier
                let breakable = propCheck.Unbreakable
                let hitCount = propCheck.hit_number
                system.runTimeout(()=>{
                    launchPlayer(player, Pknockback[0], Pknockback[1])
                },atkspd-1)
                player.addEffect("slow_falling", 16, { amplifier: 3, showParticles: false })
                attackPlayerMeikyu(player, ranger, (lavander * propCheck.damage_multiplier), blckdmg, cd, atkspd, distil, tgtnm, "line_target", attackEffect, knockback, stun, "", effects, (animations[0].length - 1), stunD, NAT, breakable, "no cooldown",weapon, hitCount, true)
            } break; 
            case "execute": {
                executer(player, burn, (lavander * 200), this.name, 44)
            } break;
            default: {
                let propCheck = animations[0][animChecker]
                let knockback = propCheck.knockback
                player.playAnimation(`animation.${propCheck.animation}`)
                atkspd = propCheck.attack_speed
                let Pknockback = propCheck.Player_Knockback 
                let effects = propCheck.type
                let stun = propCheck.stun_type
                let ranger = propCheck.range
                let distil = propCheck.distance
                let tgtnm = propCheck.targetNum
                let NAT = propCheck.next_attack_time
                let stunD = stundamage * propCheck.stun_damage_multiplier
                let breakable = propCheck.Unbreakable
                let hitCount = propCheck.hit_number
                system.runTimeout(()=>{
                    launchPlayer(player, Pknockback[0], Pknockback[1])
                },atkspd)
                if(animChecker == 3) {
                    player.addEffect("slow_falling", 16, { amplifier: 3, showParticles: false })
                }
                attackPlayerMeikyu(player, ranger, (lavander * propCheck.damage_multiplier), blckdmg, cd, atkspd, distil, tgtnm, "line_target", attackEffect, knockback, stun, "", effects, (animations[0].length - 1), stunD, NAT, breakable, "no cooldown",weapon, hitCount, true)
            }
            break;
        }
    },
    setCore(player, item) {
        let Abilities = [
            {
              Id: "S2",
            },
            {
              Id: "P3",
            },
            {
              Id: "O0",
            },
            {
              Id: "B3",
            },
            {
              Id: "O0",
            }
        ]
        item.setDynamicProperty("abilities", JSON.stringify(Abilities))
        item.setDynamicProperty("fightStyle", 1)
        player.getComponent('equippable')?.setEquipment(EquipmentSlot.Mainhand, item)
    },
    getCurrentAtkspd(player, combo) {
        let animChecker
        for(let i = (animations[0].length - 1); i > 0; i--) {
            if(player.getDynamicProperty("combo") % i == 0) {
                animChecker = i
                break;
            }
        }
        return animations[0][animChecker].attack_speed
    } 
}

export default weapon


